<?php

// add the shortcode handler for Forms button
function add_form_shotcode($atts, $content = null) {

	extract(shortcode_atts(array( "id" => '' ), $atts));
	
	$form = new WP_Query(array('p' => $id, 'post_type' => 'form'));

	if($form->have_posts())
	{
		$form->the_post();
		return get_the_content();
	}

	return "<span style='color:red;'>Warning: Form with Post ID '$id' not found!</span>";
}
add_shortcode('form', 'add_form_shotcode');


function add_form_button() {

	// Don't bother doing this stuff if the current user lacks permissions
	if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') ) 
		return;
 
	// Add only in Rich Editor mode
	if ( get_user_option('rich_editing') == 'true') {
		add_filter("mce_external_plugins", "add_form_tinymce_plugin");
		add_filter('mce_buttons', 'register_form_button');
	}
}
 
function register_form_button( $buttons ) {

	array_push($buttons, "|", "wpformin");

	return $buttons;
}
 
// Load the TinyMCE plugin : editor_plugin.js (wp2.5)
function add_form_tinymce_plugin( $plugin_array ) {

	$plugin_array['wpformin'] = WP_FORMS_JS . '/editor_plugin.js';
	return $plugin_array;
}
 
function refresh_mce($ver) {
  $ver += 4;
  return $ver;
}

// init process for button control
add_filter( 'tiny_mce_version', 'refresh_mce');
add_action('init', 'add_form_button');
?>
