/* 
 *	WP Forms jQuery method for Admin
 *
 */
jQuery(document).ready(function($){

	// Save default image source in a safe manner
	$('#form_builder_toolbox .toolbox img').each( function() {
		$(this).data( 'imgsrc', $(this).attr('src') );
	});
	
	// Spats Element on Screen
	$('#form_builder_toolbox .toolbox').click( function() {
		var img = $(this).find('img');
		$(img).attr('src', wp_form_strings['icons'] + '/loading.gif');
		$.post(ajaxurl, {action: 'create_form_element', element: $(this).attr('id')}, function(element){
			$('#form_builder_panel ul').append(element).children(':last').hide().fadeIn('normal').trigger("fireElement");
			$(img).attr('src', $(img).data('imgsrc'));
		});
	});
	
	// Style each element in "live" manner
	$("#form_builder_panel ul li").live('fireElement', function(){
	
		// Prevents Enter key to submit form in these elements
		$(this).find("input").keypress(function(e) {
			if (e.keyCode == 13) return false;
		});
		
		// Removes Element from the Screen
		$(this).find('.remove').click(function(){
			if(confirm('Do you really want to remove this element?')){
				$(this).parents('li').fadeOut('normal',function(){
					$(this).remove();
				});
			}
		});
		
		// Opens Dialog of options
		$(this).find('.edit').click(function(){
			$('#options_'+$(this).parents('li').attr('id')).dialog('open');
		});
		
	    // Select label field contents when click
		$(this).find('input.label,input.value,textarea.value').focus(function(){
		    this.select();
		});


		/*** ADVANCED OPTIONS DIALOG ***/
		// Updates hidden fields when change values from dialog		
		$(this).find("input.options_name").data('id',$(this).attr('id')).change(function() {
			$("#"+$(this).data('id')+' input.name').val($(this).val());
		});
		
		$(this).find("input.options_required").data('id',$(this).attr('id')).click(function() {
			$("#"+$(this).data('id')+' input.required').val(($(this).is(':checked'))?'required:true':'');
		});
	
		$(this).find("select.options_size").data('id',$(this).attr('id')).change(function() {
			var id = $(this).data('id');
			$("#"+id+' input.value').removeClass('small medium large').addClass($(this).val());
			$("#"+id+' textarea.value').removeClass('small medium large').addClass($(this).val());
			$("#"+id+' input.size').val($(this).val());
		});
	

		$(this).find("textarea.options_values").data('id',$(this).attr('id')).keyup(function() {
				
			var id = $(this).data('id');
			var options = "";
				
			if($("#"+id+" input.type").val()=='dropdown')
				$("#element_"+id+' select').find('option').remove();
			else
				$("#element_"+id).find(':visible, span, br').remove();
				
			$.each($(this).val().split('\n'), function(i,opt){
							
				switch($("#"+id+" input.type").val())
				{
					case 'dropdown': $("#element_"+id+" select").append('<option value="'+opt+'">'+opt+'</option><br/>'); break;
					case 'checkbox': $("#element_"+id).append("<input type='checkbox' class='value' name='elements["+id+"]['value']' value='"+opt+"' /><span>"+opt+"</span><br/>"); break;
					case 'radio': $("#element_"+id).append("<input type='radio' class='value' name='elements["+id+"]['value']' value='"+opt+"' /><span>"+opt+"</span><br/>"); break;
				}
				options += opt+',';
			});
			
			$("#element_"+id).find('input.options').val(options.slice(0,-1));

		});
		
		// Creates the Dialog		
		$('#options_'+$(this).attr('id')).dialog({
			height:350, 
			modal:true,
			//TODO: Make it Save and Restore Values (maybe?...)
			buttons: {
				'Save': function(){
					$(this).dialog("close");
				},
				'Cancel': function(){
					$(this).dialog("close");
				},
			}
		}).dialog('close');
		
	});
	
	// Make elements sortable
	$("#form_builder_panel ul#sortable").sortable({
		placeholder: 'state-default',
		items: 'li',
		opacity: 0.6,
		helper: 'original',
		delay: 200,
		distance: 15,
		update: function(event, ui){
			$('#elements_order').val($(this).sortable('toArray').toString());
		}
	});
	
	// Fire elements already there
	$("#form_builder_panel ul li").trigger("fireElement");

});
