<?php

/*
 * Form Creator HELPER
 *
 */

function form_mcearea( $id, $value = "", $size = "medium" )
{
	$html = "";
	//$html .= "<div id='editor-toolbar'><div id='media-buttons' class='hide-if-no-js'>";
	//$html .= media_buttons();
	//$html .= "</div><div id='editorcontainer'>";
	//$html .= wp_tiny_mce( false , array("editor_selector" => $id, "height" => 250) );
	$html .= "<textarea class='value content wysiwyg' id='$id' name='elements[$id][value]' class='$size' style='width:100%; height:150px; font-size:0.8em;'>$value</textarea>";
	//$html .= "</div></div>";

	return $html;
}


function form_text( $id, $value = "Default Text", $size = "medium", $required = "" )
{
	$html = "<input type='text' title='Enter a default value' class='$size text value' name='elements[$id][value]' value='$value' style='background:url('".WP_FORMS_IMGLANG."text-en_US.png') right center no-repeat;' />";
	
	return $html;
}


function form_email( $id, $value = "@", $size = "medium", $required = "" )
{
	$html = "<input type='text' title='Enter a default value' class='$size email value' name='elements[$id][value]' value='$value' style='background:url('".WP_FORMS_IMGLANG."email-en_US.png') right center no-repeat;' />";
	
	return $html;
}


function form_number( $id, $value = "12345", $size = "medium", $required = "" )
{
	$html = "<input type='text' title='Enter a default value' class='$size number value' name='elements[$id][value]' value='$value' style='background:url('".WP_FORMS_IMGLANG."number-en_US.png') right center no-repeat;' />";
	
	return $html;
}


function form_name( $id, $values = array("Default First","Default Last"), $size = "large", $required = "" )
{
	$html = "<span style='width:50%' class='small'>";
	$html .= "<input type='text' title='Enter a default value' class='$size value' name='elements[$id][values][0]' value='{$values[0]}' />";
	$html .= "<label>First Name</label>";
	$html .= "</span>";
	
	$html .= "<span style='width:50%' class='small'>";
	$html .= "<input type='text' title='Enter a default value' class='$size value' name='elements[$id][values][1]' value='{$values[1]}' />";
	$html .= "<label>Last Name</label>";
	$html .= "</span>";
	
	$html .= "<div class='clear'></div>";
	
	return $html;
}


function form_phone( $id, $value = "Default Phone", $size = "medium", $format = "xxx-xxx-xxxx", $required = "" )
{
	$html = "<input type='text' title='Enter a default value' class='$size phone value' name='elements[$id][value]' value='$value' />";
	//TODO: $html .= "<input type='hidden' class='format' name='elements[$id]['format']' value='$format' />";
	
	return $html;
}

 
function form_date( $id, $values = array("10", "10", "2010"), $format = "dd-mm-yyyy", $required = "" )
{
	$html = "<input type='hidden' size='10' class='picker' value='' />";

	$html .= "<span class='small'>";
	$html .= "<input type='text' class='day value' size='3' maxlenght='2' name='elements[$id][values][0]' value='{$values[0]}' />";
	$html .= "<label>Day</label>";
	$html .= "</span>";
	
	$html .= "<span class='small'>&nbsp;/&nbsp;</span>";
	
	$html .= "<span class='small'>";
	$html .= "<input type='text' class='month value' size='3' maxlenght='2' name='elements[$id][values][1]' value='{$values[1]}' />";
	$html .= "<label>Month</label>";
	$html .= "</span>";
	
	$html .= "<span class='small'>&nbsp;/&nbsp;</span>";
	
	$html .= "<span class='small'>";
	$html .= "<input type='text' class='year value' size='5' maxlenght='4' name='elements[$id][values][2]' value='{$values[2]}' />";
	$html .= "<label>Year</label>";
	$html .= "</span>";
	
	$html .= "<a href='#'><img src='images/icons/calendar.gif' /></a>";
	$html .= "<script type='text/javascript'></script>";

	$html .= "<div class='clear'></div>";
	
	return $html;
}

function form_time( $id, $values = array("21","00"), $required = "" )
{
	$html = "<span class='small'>";
	$html .= "<input type='text' class='value' size='3' maxlength='2' name='elements[$id][values][0]' value='{$values[0]}' />";
	$html .= "<label>Hour</label>";
	$html .= "</span>";
	
	$html .= "<span class='small'>&nbsp;:&nbsp;</span>";
	
	$html .= "<span class='small'>";
	$html .= "<input type='text' class='value' size='3' maxlength='2' name='elements[$id][values][1]' value='{$values[1]}' />";
	$html .= "<label>Minutes</label>";
	$html .= "</span>";
	
	$html .= "<div class='clear'></div>";
	
	return $html;
}

function form_textarea( $id, $value = "", $size = "medium", $required = "" )
{
	$html = "<textarea type='text' class='$size value' name='elements[$id][value]' />$value</textarea>";
	
	return $html;
}

function form_dropdown( $id, $value = false, $values = array("Edit options in Advanced Options window"), $size = "medium", $required = "" )
{	
	$html = "<select class='$size value' name='elements[$id][value]' class='$size'>";
	
	foreach( $values as $val )
	{
		$selected = ( $val == $value ) ? " selected='selected'" : "";
		$html .= "<option value='$val'$selected>$val</option>";
	}
	
	$html .= "</select>";
	
	$html .= "<input type='hidden' class='options' name='elements[$id][values]' value='".implode(',', $values)."' />";
	
	return $html;
}

function form_radio( $id, $value = false, $values = array("Edit options in Advanced Options window"), $required = "" )
{
	$html = "";
	foreach( $values as $val )
	{
		$selected = ( $val == $value ) ? " selected='selected'" : "";
		$html .= "<input type='radio' class='value' name='elements[$id][value]' value='$val' $selected/><span>$val</span><br/>";
	}

	$html .= "<input type='hidden' class='options' name='elements[$id][values]' value='".implode(',', $values)."' />";
	
	return $html;
}

//TODO: accepts values that are checked by default
function form_checkbox( $id, $values = array("Edit options in Advanced Options window"), $required = "" )
{
	$html = "";
	foreach( $values as $value )
		$html .= "<input type='checkbox' class='value' name='elements[$id][value]' value='$value' /><span>$value</span><br/>";
	
	$html .= "<input type='hidden' class='options' name='elements[$id][values]' value='".implode(',', $values)."' />";
	
	return $html;
}

function form_fileupload( $id, $value = "", $size = "medium", $required = "" )
{
	$html = "<input type='file' class='$size value' name='elements[$id][value]' />";
	
	return $html;
}

function form_add_advanced_options( $id, $name, $type, $size = "medium", $required = false, $values = "")
{

	if( $type == 'paragraph') return;
	
	$required = ($required=='required:true') ? "checked='checked' " : "";

	$return = "<div id='options_$id' class='$id' title='Advanced Options'>";
	$return .= "<p><label for='name_$id'>Element Name: </label><br/><input id='name_$id' type='text' class='options_name' style='width:100%' name='$id[name]' value='{$name}'/></p>";
	$return .= "<p><input id='required_$id' type='checkbox' class='options_required' name='$id[required]' $required/> <label for='required_$id'>Check if this element is <span class='red bold'>Required</span></label></p>";
	$return .= "<input type='hidden' class='type' name='options_type' value='$type'/>";


	switch( $type )
	{
	
		case 'text': 
		case 'email': 
		case 'number':  
		case 'phone': 
		//TODO: Out-of-the-box elements - Later Work
		//case 'address': $element = form_address( $id ); break;
		//case 'price': $element = form_price( $id ); break;
		case 'textarea':

			$sizes = array('small' => 'Small size', 'medium' => 'Medium size', 'large' => 'Large size');
			$return .= "<p><label for='size_$id'>Size of the Element: </label><br/><select id='size_$id' class='options_size' style='width:100%' name='$id[size]'>";
			foreach( $sizes as $key => $value )
				if( $key == $size )
					$return .= "<option value='$key' selected='selected'>$value</option>";
				else
					$return .= "<option value='$key'>$value</option>";
			$return .= "</select></p>";
		
		case 'name':
		case 'date': 
		case 'time': 
		case 'fileupload': 
 
			$return .= ""; break;
		
		case 'dropdown': 
		case 'checkbox': 
		case 'radio': 
				
			$values = (!empty($values) ? implode("\n",explode(",",$values)) : "");
			$return .= "<p><label for='values_$id'>Enter Options one per line:</label><br /><textarea id='values_$id' class='options_values' name='$id[values]' style='width:100%;height:100px;'>".$values."</textarea></p>";
			break;

	}
	
	$return .= "</div>";
	
	return $return;	
}

?>
